using JiShe.CollectBus.Protocol.Dto;
using JiShe.CollectBus.Protocol.Interfaces;
using JiShe.CollectBus.Protocol3761;
using Microsoft.Extensions.Logging;

namespace JiShe.CollectBus.Protocol.T37612012.AnalysisData.AFN_00H
{
    /// <summary>
    /// 5.1.3.2 F2：全部否认
    /// </summary>
    public class AFN0_F2_Analysis : IAnalysisStrategy<TB3761>
    {
        private readonly ILogger<AFN0_F2_Analysis> _logger;

        public AFN0_F2_Analysis(ILogger<AFN0_F2_Analysis> logger)
        {
            _logger = logger;
        }
        public Task<bool> ExecuteAsync(TB3761 input, Action<dynamic>? result = null)
        {
            try
            {
                ArgumentNullException.ThrowIfNull(input);
                ArgumentNullException.ThrowIfNull(input.A.Code);
                UnitDataAnalysis<bool> dto = new UnitDataAnalysis<bool>
                {
                    Code = input.A.Code,
                    AFN = input.AFN_FC.AFN,
                    Fn = input.DT.Fn,
                    Pn = input.DA.Pn,
                    Data = false,
                    HexMessage = input.BaseHexMessage.HexMessageString,
                    MessageId = input.MessageId,
                    ReceivedTime =input.ReceivedTime
                };
                result?.Invoke(dto);
                return Task.FromResult(true);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, $"00_2解析失败:{input.A.Code}-{input.DT.Fn}-{input.BaseHexMessage.HexMessageString},{ex.Message}");
                return Task.FromResult(false);
            }
        }

       
    }
}
